org.apache.solr.cloud

## Class LeaderInitiatedRecoveryThread

- java.lang.Object
- - java.lang.Thread
  - - org.apache.solr.cloud.LeaderInitiatedRecoveryThread

- All Implemented Interfaces:
    Runnable

      public class LeaderInitiatedRecoveryThread
      extends Thread

  Background daemon thread that tries to send the REQUESTRECOVERY to a downed replica; used by a shard leader to nag a replica into recovering after the leader experiences an error trying to send an update request to the replica.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.lang.Thread

      `Thread.State, Thread.UncaughtExceptionHandler`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `collection`
    `protected CoreContainer` | `coreContainer`
    `protected int` | `maxTries`
    `protected ZkCoreNodeProps` | `nodeProps`
    `protected String` | `shardId`
    `protected ZkController` | `zkController`

    - ### Fields inherited from class java.lang.Thread

      `MAX_PRIORITY, MIN_PRIORITY, NORM_PRIORITY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LeaderInitiatedRecoveryThread(ZkController zkController, CoreContainer cc, String collection, String shardId, ZkCoreNodeProps nodeProps, int maxTries, CoreDescriptor leaderCd)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `publishDownState(String replicaCoreName, String replicaCoreNodeName, String replicaNodeName, String replicaUrl, boolean forcePublishState)`
    `void` | `run()`
    `protected void` | `sendRecoveryCommandWithRetry()`
    `protected void` | `updateLIRState(String replicaCoreNodeName)`

    - ### Methods inherited from class java.lang.Thread

      `activeCount, checkAccess, clone, countStackFrames, currentThread, destroy, dumpStack, enumerate, getAllStackTraces, getContextClassLoader, getDefaultUncaughtExceptionHandler, getId, getName, getPriority, getStackTrace, getState, getThreadGroup, getUncaughtExceptionHandler, holdsLock, interrupt, interrupted, isAlive, isDaemon, isInterrupted, join, join, join, resume, setContextClassLoader, setDaemon, setDefaultUncaughtExceptionHandler, setName, setPriority, setUncaughtExceptionHandler, sleep, sleep, start, stop, stop, suspend, toString, yield`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### zkController

          protected ZkController zkController

    - #### coreContainer

          protected CoreContainer coreContainer

    - #### collection

          protected String collection

    - #### shardId

          protected String shardId

    - #### nodeProps

          protected ZkCoreNodeProps nodeProps

    - #### maxTries

          protected int maxTries

  - ### Constructor Detail

    - #### LeaderInitiatedRecoveryThread

          public LeaderInitiatedRecoveryThread(ZkController zkController,
                                               CoreContainer cc,
                                               String collection,
                                               String shardId,
                                               ZkCoreNodeProps nodeProps,
                                               int maxTries,
                                               CoreDescriptor leaderCd)

  - ### Method Detail

    - #### run

          public void run()

      Specified by:
        `run` in interface `Runnable`
      Overrides:
        `run` in class `Thread`

    - #### publishDownState

          public boolean publishDownState(String replicaCoreName,
                                          String replicaCoreNodeName,
                                          String replicaNodeName,
                                          String replicaUrl,
                                          boolean forcePublishState)

    - #### updateLIRState

          protected void updateLIRState(String replicaCoreNodeName)

    - #### sendRecoveryCommandWithRetry

          protected void sendRecoveryCommandWithRetry()
                                               throws Exception

      Throws:
        `Exception`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.